package com.learning.item;


import java.util.function.Function;

import com.learning.Learning;
import com.learning.component.Foods; 
import com.learning.item.Toast;

import net.minecraft.item.Item;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.registry.RegistryKey;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.util.Identifier;
import net.minecraft.component.type.ConsumableComponents;

public class CustomItem {
  public static void registerItems() {
    Learning.LOGGER.info("Registering Items...");
  }

  public static Item toast = register("toast", Toast::new, new Item.Settings().food(Foods.toastFood, ConsumableComponents.food().consumeSeconds(0.5f).build()));

  private static Item register(String itemId) {
    return register(itemId, new Item.Settings());
  }

  private static Item register(String itemId, Item.Settings settings) {
    return register(itemId, Item::new, settings);
  }
  
  private static Item register(String itemId, Function<Item.Settings, Item> factory, Item.Settings settings) {
    RegistryKey<Item> key = keyOf(itemId);
    return Registry.register(Registries.ITEM, key, factory.apply(settings.registryKey(key)));
  }
  private static RegistryKey<Item> keyOf(String itemId) {
    return RegistryKey.of(RegistryKeys.ITEM, Identifier.of(Learning.MOD_ID, itemId));
  }
}
